<?php

namespace Fufle\ORM\Database;

class QueryData {
    public function __construct(
        public string $query,
        public array|object $params
        ) {

    }

    public function normalize() {
        $params = (array)$this->params;
        $replaces = [];
        foreach($params as $name => $param) {
            if (is_array($param)) {
                $replaces2 = [];
                foreach($param as $i => $p) {
                    $params[$name.$i.'x'] = $p;
                    $replaces[] = ':'.$name.$i.'x';
                }
                unset($params[$name]);
                $this->query = str_replace(':'.$name, implode(', ', $replaces), $this->query);
            }
        }
        $this->params = $params;
    }
}